package cn.aibreeze.exam.facade;

import com.alibaba.fastjson2.JSONObject;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.http.HttpEntity;
import org.springframework.http.HttpHeaders;
import org.springframework.http.MediaType;
import org.springframework.http.ResponseEntity;
import org.springframework.scheduling.annotation.Async;
import org.springframework.stereotype.Component;
import org.springframework.web.client.RestTemplate;

import java.util.HashMap;
import java.util.Map;


@Component
@Slf4j
public class ExamAppFacade {

    @Value("${dify.api_base:https://ai-api.tech.breezeai.cn/v1}")
    private String difyBase;

    @Value("${dify.api_key:app-yaoa2lAMGJzB11ZGxd5P4iTQ}")
    private String apiKey;

    private final RestTemplate restTemplate = new RestTemplate();


    @Async
    public void run4Score(String scene, String sessionId, String userId, String question, String answer, String userAnswer) {
        Map<String, String> inputs = new HashMap<>();
        inputs.put("scene", scene);
        inputs.put("question", question);
        inputs.put("answer", answer);
        JSONObject param = new JSONObject();
        param.put("query", userAnswer);
        param.put("inputs", inputs);
        param.put("response_mode", "blocking");
        param.put("conversation_id", "");
        param.put("user", userId);
        HttpHeaders headers = new HttpHeaders();
        headers.setContentType(MediaType.APPLICATION_JSON);
        headers.setBearerAuth(apiKey);

        log.info("异步请求参数，sessionId = {}", sessionId);
        log.info("异步请求参数，req = {}", JSONObject.toJSONString(param));
        HttpEntity<String> postEntity = new HttpEntity<>(param.toJSONString(), headers);
        ResponseEntity<String> response = restTemplate.postForEntity(difyBase + "/chat-messages", postEntity, String.class);
        log.info("执行结果：", JSONObject.parseObject(response.getBody()));
    }

}
